import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.nio.ByteBuffer;

import javax.swing.JLabel;
import javax.swing.JTextField;


public class Main {

	private JFrame frame;
	LibRS232 rs232 = new LibRS232(); //Objeto LibRS232 para abrir puertos
	JLabel lblAccion ; //Etiqueta para dar el estatus de la conexin con los puertos
	JComboBox comboBox ; //Combo Box que contendr una lista con los puertos COM disponibles
	public SADERevB comando =new SADERevB(); //El objeto SADE. Contiene todos los mtodos de acquisicin
	public static boolean reset = false;
	Thread t;
	Hilo hilo;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 450, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		comboBox = new JComboBox();
		comboBox.setModel(new DefaultComboBoxModel(new String[] {"Actualizar"}));
		
		
		hilo = new Hilo(this);
		t = new Thread(hilo);
		
		/*
		 * Busca puertos COM y los guarda en un array de bytes. El array contiene el nmero de los 
		 * puertos encontrados. P/E si se encontraron los puertos COM4 y COM5, entonces
		 * el array tendra la siguiente informacin: 
		 * puertos[0] = 4
		 * puertos[1] = 5
		 */
		byte[] puertos = rs232.RS232EncuentraPuertos();
		
		/*
		 * Los puertos encontrados se agregan al Combo Box de la aplicacin princial agregando 
		 * la palabra "COM" seguida del valor encontrado por el mtodo RS232EncuentraPuertos
		 */
		for(int i=0; i<puertos.length;i++){
			comboBox.addItem("COM"+puertos[i]);
		}
		
		lblAccion = new JLabel("Puertos...");
		GroupLayout groupLayout = new GroupLayout(frame.getContentPane());
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addComponent(comboBox, GroupLayout.PREFERRED_SIZE, 93, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(lblAccion)
					.addContainerGap(177, Short.MAX_VALUE))
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(comboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(lblAccion))
					.addContainerGap(218, Short.MAX_VALUE))
		);
		frame.getContentPane().setLayout(groupLayout);
		
		
	}
}
